// ---------------------------------------------------------------------------
// xhair.cs -- Version 2.2 -- October 27, 2000
// by Lorne Laliberte (Writer -- writer@planetstarsiege.com)
//
// Weapon-specific reticles and rangefinders
//
// http://www.writerscripts.com
// ---------------------------------------------------------------------------

include("writer\\version.cs");
version("writer\\xhair.cs", "2.1", "Lorne Laliberte", "Oct 27, 2000");

include("writer\\event.cs");
include("writer\\inventory.cs");
include("writer\\menu.cs");
include("writer\\save.cs");
include("writer\\screensize.cs");
include("writer\\weapon_switch.cs");
include("writer\\whud.cs");
include("writer\\you_died.cs");
include("writer\\you_respawned.cs");

// ---------------------------------------------------------------------------
// DEFAULT SETTINGS:
//
// Edit these if you're running this script for the first time
// All subsequent settings must be done in the config\wp_xhair.cs file

    // Enter xhair config mode
    //bind(keyboard0, make, r_alt, "x", to, "Xhair::configMode();");
    //bind(keyboard0, break, r_alt, "x", to, "", "Xhair::configMode_break");

    // Toggle your "command mode" reticle and rangefinders on/off
    //bind(keyboard0, make, r_alt, "c", to, "Xhair::CommandModeToggle();");
    //bind(keyboard0, break, r_alt, "c", to, "", "Xhair::CommandModeToggle_break");

    // Force your "Mortar" reticle and rangefinders on/off
    //bind(keyboard0, make, r_alt, "m", to, "Xhair::ForceMortarToggle();");
    //bind(keyboard0, break, r_alt, "m", to, "", "Xhair::ForceMortarToggle_break");

// ---------------------------------------------------------------------------

WriterPrefs::mount("xhairsupport", "writer\\xhair.vol");
WriterPrefs::load("xhair");

// Delay in seconds before a key will start repeating
$Xhair::keyFirstDelay = 0.5;

// Delay in seconds between key repeats (repeat rate)
$Xhair::keyRepeatDelay = 0.1;

// Default width and height in pixels for the reticles
$Xhair::width = 63;
$Xhair::height = 63;

$Rangefinder::top::width = 63;
$Rangefinder::top::height = 241;

$Rangefinder::bottom::width = 63;
$Rangefinder::bottom::height = 250;

$Xhair::nameCount += 0;


function Xhair::custom(%file, %width, %height)
{
    $Xhair::width["<b1,1:" @ %file @ ">"] = %width;
    $Xhair::height["<b1,1:" @ %file @ ">"] = %height;
}


Xhair::custom("writer\\rangefinders\\Grenade_800.bmp", 63, 215);
Xhair::custom("writer\\rangefinders\\Grenade_640.bmp", 63, 180);

Xhair::custom("writer\\rangefinders\\Mortar_800.bmp", 63, 215);
Xhair::custom("writer\\rangefinders\\Mortar_640.bmp", 63, 180);

Xhair::custom("writer\\xhairs\\terr_001.bmp", 160, 120);


function Xhair::setup()
{
    %file = File::findFirst("writer\\xhairs\\*.bmp");
    $Xhair::count = 0;
    while(%file != "")
    {
        $Xhair::list[$Xhair::count] = "<b1,1:" @ %file @ ">";
        $Xhair::count++;
        %file = File::findNext("writer\\xhairs\\*.bmp");
    }

    $Xhair::list[$Xhair::count] = "";
    $Xhair::count++;


    %file = File::findFirst("writer\\rangefinders\\*.bmp");
    $Rangefinder::count = 0;
    while(%file != "")
    {
        $Rangefinder::list[$Rangefinder::count] = "<b1,1:" @ %file @ ">";
        $Rangefinder::count++;
        %file = File::findNext("writer\\rangefinders\\*.bmp");
    }

    $Rangefinder::list[$Rangefinder::count] = "";
    $Rangefinder::count++;
}


// In order to save the data for weapons that aren't available at the
// current server, we need a more permanent list of the weapons that we've
// assigned bitmaps to.
//
function Xhair::addWeapon(%weapon)
{
    if((%weapon == pilotmode) || (%weapon == default))
        return;

    %already = false;
    for(%i = 0; %i < $Xhair::nameCount; %i++)
    {
        if($Xhair::weaponName[%i] == %weapon)
        {
            %already = true;
            break;
        }
    }
    if(%already)
        return;

    $Xhair::weaponName[$Xhair::nameCount] = %weapon;
    $Xhair::nameCount++;
}


function Xhair::saveData()
{
    flushExportText();
    newObject(xhairSave, fearguiformattedtext,0,0,0,0);

    AddExportText("// ---------------------------------------------------------------------------");
    AddExportText("// xhair_data.cs -- Version 1.4 -- March 16, 2000");
    AddExportText("// by Lorne Laliberte (writer@planetstarsiege.com)");
    AddExportText("//");
    AddExportText("// http://www.writerscripts.com");
    AddExportText("// ---------------------------------------------------------------------------");
    AddExportText("");
    AddExportText("// The format is:");
    AddExportText("//");
    AddExportText("// Xhair::addWeapon(<weapon name>);");
    AddExportText("// $Xhair::bitmap[<weapon name>] = <bitmap code with full path to reticle>");
    AddExportText("// $Rangefinder::top::bitmap[<weapon name>] = <bitmap code with full path to upper rangefinder>");
    AddExportText("// $Rangefinder::bottom::bitmap[<weapon name>] = <bitmap code with full path to lower rangefinder>");
    AddExportText("//");
    AddExportText("// There are two special weapon names:  [default] and the [pilotmode]");
    AddExportText("//");
    AddExportText("// [default] gets used for weapons that have no bitmap specified");
    AddExportText("// [pilotmode] gets used while Pilot Mode is enabled");
    AddExportText("//");
    AddExportText("// The default reticle size is 63 x 63 pixels.  If you want to use a reticle with");
    AddExportText("// different dimensions, you must set the width and height for that reticle from");
    AddExportText("// a script (like your autoexec.cs file) using the");
    AddExportText("// Xhair::custom(<path to file below config>, <width>, <height>) function.");
    AddExportText("//");
    AddExportText("// Example:");
    AddExportText("//");
    AddExportText("// Xhair::custom(\"writer\\\\xhairs\\\\bigreticle.bmp\", 100, 100);");
    AddExportText("//");
    AddExportText("// You can have as many sizes of reticles as you like, but you must call");
    AddExportText("// Xhair::custom() for each of them, or they won't be centered on the screen.");
    AddExportText("//");
    AddExportText("// Note that you may need to adjust your settings for the laser_ready.cs energy bar");
    AddExportText("// and the xHUD.cs zoom indicator to fit around larger reticles.");
    AddExportText("");
    AddExportText("");

    AddExportText("$Xhair::bitmap[default] = \"" @ escapestring($Xhair::bitmap[default]) @ "\";");
    AddExportText("$Rangefinder::top::bitmap[default] = \"" @ escapestring($Rangefinder::top::bitmap[default]) @ "\";");
    AddExportText("$Rangefinder::bottom::bitmap[default] = \"" @ escapestring($Rangefinder::bottom::bitmap[default]) @ "\";");
    AddExportText("");

    AddExportText("$Xhair::bitmap[pilotmode] = \"" @ escapestring($Xhair::bitmap[pilotmode]) @ "\";");
    AddExportText("$Rangefinder::top::bitmap[pilotmode] = \"" @ escapestring($Rangefinder::top::bitmap[pilotmode]) @ "\";");
    AddExportText("$Rangefinder::bottom::bitmap[pilotmode] = \"" @ escapestring($Rangefinder::bottom::bitmap[pilotmode]) @ "\";");
    AddExportText("");

    AddExportText("$Xhair::bitmap[command] = \"" @ escapestring($Xhair::bitmap[command]) @ "\";");
    AddExportText("$Rangefinder::top::bitmap[command] = \"" @ escapestring($Rangefinder::top::bitmap[command]) @ "\";");
    AddExportText("$Rangefinder::bottom::bitmap[command] = \"" @ escapestring($Rangefinder::bottom::bitmap[command]) @ "\";");
    AddExportText("");

    for(%i = 0; %i < $Xhair::nameCount; %i++)
    {
        AddExportText("Xhair::addWeapon(\"" @ escapestring($Xhair::weaponName[%i]) @ "\"); // allows xhair.cs to save settings for the \"" @ escapestring($Xhair::weaponName[%i]) @ "\"");
        AddExportText("$Xhair::bitmap[\"" @ escapestring($Xhair::weaponName[%i]) @ "\"] = \"" @ escapestring($Xhair::bitmap[$Xhair::weaponName[%i]]) @ "\";");
        AddExportText("$Rangefinder::top::bitmap[\"" @ escapestring($Xhair::weaponName[%i]) @ "\"] = \"" @ escapestring($Rangefinder::top::bitmap[$Xhair::weaponName[%i]]) @ "\";");
        AddExportText("$Rangefinder::bottom::bitmap[\"" @ escapestring($Xhair::weaponName[%i]) @ "\"] = \"" @ escapestring($Rangefinder::bottom::bitmap[$Xhair::weaponName[%i]]) @ "\";");
        AddExportText("");
    }


    AddExportText("// Remove the xhairSave object that gets created whenever this file is executed");
    AddExportText("if(isObject(xhairSave))");
    AddExportText("    deleteobject(xhairSave);");

    exportObjectToScript(xhairSave, "config\\xhair_data.cs", true);
    deleteobject(xhairSave);
    flushExportText();

    echo();
    echo("config\\xhair_data.cs saved!");
    echo();
}


function Xhair::update(%weapon, %force)
{
    if(%weapon == "")
        %weapon = $Inv::Name[getMountedItem(0)];

    $Xhair::currentWeapon = %weapon;

    if((%width = $Xhair::width[$Xhair::bitmap[%weapon]]) == "")
        %width = $Xhair::width;

    if((%height = $Xhair::height[$Xhair::bitmap[%weapon]]) == "")
        %height = $Xhair::height;

    if(!%force && ($Xhair::bitmap[%weapon] == $Xhair::currentBitmap))
        return;

    $Xhair::currentBitmap = $Xhair::bitmap[%weapon];

    if($Xhair::currentBitmap == "")
        $Xhair::currentBitmap = $Xhair::bitmap[default];

    if($Xhair::currentBitmap == "")
    {
        wHUD::hide(xhair);
    }
    else
    {
        if(!wHUD::exists(xhair) || (%width != $Xhair::currentWidth) || (%height != $Xhair::currentHeight))
        {
            wHUD::make(xhair, "50%", "50%", %width, %height, 1, 1, $Xhair::currentBitmap);
            Event::Trigger(eventXhairDimensionsChanged);
        }
        else
            wHUD::show(xhair, $Xhair::currentBitmap);
    }

    $Xhair::currentWidth = %width;
    $Xhair::currentHeight = %height;

    if((%width = $Xhair::width[$Rangefinder::top::bitmap[%weapon]]) == "")
        %width = $Rangefinder::top::width;

    if((%height = $Xhair::height[$Rangefinder::top::bitmap[%weapon]]) == "")
        %height = $Rangefinder::top::height;

    if(!%force && ($Rangefinder::top::bitmap[%weapon] == $Rangefinder::top::currentBitmap))
        return;

    $Rangefinder::top::currentBitmap = $Rangefinder::top::bitmap[%weapon];

    if($Rangefinder::top::currentBitmap == "")
        $Rangefinder::top::currentBitmap = $Rangefinder::top::bitmap[default];

//    %y = floor((getScreensizeY() - 1 + $Xhair::currentHeight)/2);

    if($Rangefinder::top::currentBitmap == "")
    {
        wHUD::hide(rangefinderTop);
        Event::Trigger(eventRangefinderOff);
    }
    else
    {
        if(!wHUD::exists(rangefinderTop) || (%width != $Rangefinder::top::currentWidth) || (%height != $Rangefinder::top::currentHeight) || (%y != $Rangefinder::top::currentY))
            wHUD::make(rangefinderTop, "50%", "b:xhair", %width, %height, 1, 1, $Rangefinder::top::currentBitmap);
        else
            wHUD::show(rangefinderTop, $Rangefinder::top::currentBitmap);

        Event::Trigger(eventRangefinderOn);
    }

    $Rangefinder::top::currentWidth = %width;
    $Rangefinder::top::currentHeight = %height;
//    $Rangefinder::top::currentY = %y;

    if((%width = $Xhair::width[$Rangefinder::bottom::bitmap[%weapon]]) == "")
        %width = $Rangefinder::bottom::width;

    if((%height = $Xhair::height[$Rangefinder::bottom::bitmap[%weapon]]) == "")
        %height = $Rangefinder::bottom::height;

    if(!%force && ($Rangefinder::bottom::bitmap[%weapon] == $Rangefinder::bottom::currentBitmap))
        return;

    $Rangefinder::bottom::currentBitmap = $Rangefinder::bottom::bitmap[%weapon];

    if($Rangefinder::bottom::currentBitmap == "")
        $Rangefinder::bottom::currentBitmap = $Rangefinder::bottom::bitmap[default];

//    %y = $Rangefinder::top::currentY + $Rangefinder::top::currentHeight;

    if($Rangefinder::bottom::currentBitmap == "")
    {
        wHUD::hide(rangefinderBottom);
    }
    else
    {
        if(!wHUD::exists(rangefinderBottom) || (%width != $Rangefinder::bottom::currentWidth) || (%height != $Rangefinder::bottom::currentHeight) || (%y != $Rangefinder::bottom::currentY))
            wHUD::make(rangefinderBottom, "50%", "b:rangefinderTop", %width, %height, 1, 1, $Rangefinder::bottom::currentBitmap);
        else
            wHUD::show(rangefinderBottom, $Rangefinder::bottom::currentBitmap);
    }

    $Rangefinder::bottom::currentWidth = %width;
    $Rangefinder::bottom::currentHeight = %height;
//    $Rangefinder::bottom::currentY = %y;
}


function Xhair::relocate()
{
    wHUD::remove(xhair);
    wHUD::remove(rangefinder1);
    wHUD::remove(rangefinder2);
    Xhair::update($Xhair::currentWeapon, true);
    return;
}

function Xhair::onDropWeapon(%weapon)
{
    Xhair::update(default);
    return;
}


function Xhair::onWeaponSwitch(%toWeapon, %fromWeapon)
{
    if($PilotMode)
        return;

    if($Xhair::CommandMode)
        $Xhair::CommandMode = false;

    if($Xhair::MortarMode)
        $Xhair::MortarMode = false;

    Xhair::update($Inv::Name[%toWeapon]);
    return;
}

function Xhair::onYouRespawned()
{
    Xhair::update("", true);
    return;
}


function Xhair::CommandModeToggle()
{
    if($Xhair::CommandMode = !$Xhair::CommandMode)
    {
        $Xhair::MortarMode = false;
        Xhair::update(command);
    }
    else
        Xhair::update();

    return;
}


function Xhair::ForceMortarToggle()
{
    if($Xhair::MortarMode = !$Xhair::MortarMode)
    {
        $Xhair::CommandMode = false;
        Xhair::update("Mortar");
    }
    else
        Xhair::update();

    return;
}


function Xhair::onExitCommandStation()
{
    $Xhair::CommandMode =
    $Xhair::MortarMode = false;
    Xhair::update();
    return;
}


function Xhair::onPilotModeOn()
{
    Xhair::update(pilotmode);
    return;
}

function Xhair::onPilotModeOff()
{
    Xhair::update($Inv::Name[getMountedItem(0)], true);
    return;
}


function Xhair::hide()
{
    wHUD::hide(xhair);
    wHUD::hide(rangefinder1);
    wHUD::hide(rangefinderTop);
    return;
}


function Xhair::bindCommonKeys()
{
    editActionMap("xhairMap.sae");

    bindCommand(keyboard0, make, "enter", TO, "Xhair::enter();");
    bindCommand(keyboard0, break, "enter", TO, "");
    bindCommand(keyboard0, make, "numpadenter", TO, "Xhair::enter();");
    bindCommand(keyboard0, break, "numpadenter", TO, "");
    bindCommand(keyboard0, break, "left", TO, "Xhair::prevReleased();");
    bindCommand(keyboard0, break, "right", TO, "Xhair::nextReleased();");

    // We need to mute some events to prevent the user from switching weapons
    Event::Attach(eventUse, Xhair::mute);
    Event::Attach(eventDrop, Xhair::mute);
    Event::Attach(eventNextWeapon, "return mute;");
    Event::Attach(eventPrevWeapon, "return mute;");
}


function Xhair::mute(%itemtype, %itemname)
{
    if($Inv::isWeapon[%itemtype])
        return mute;

    if(%itemtype == $Inv::Repair_Pack)
        return mute;

    return;
}


function Xhair::bindKeys()
{
    newActionMap("xhairMap.sae");

    bindCommand(keyboard0, make, "escape", TO, "Xhair::cancel();");
    bindCommand(keyboard0, break, "escape", TO, "");
    bindCommand(keyboard0, make, "left", TO, "Xhair::prevPressed();");
    bindCommand(keyboard0, make, "right", TO, "Xhair::nextPressed();");
    Xhair::bindCommonKeys();
}


function Rangefinder::top::bindKeys()
{
    newActionMap("xhairMap.sae");

    bindCommand(keyboard0, make, "escape", TO, "Rangefinder::top::cancel();");
    bindCommand(keyboard0, break, "escape", TO, "");
    bindCommand(keyboard0, make, "left", TO, "Rangefinder::top::prevPressed();");
    bindCommand(keyboard0, make, "right", TO, "Rangefinder::top::nextPressed();");
    Xhair::bindCommonKeys();
}


function Rangefinder::bottom::bindKeys()
{
    newActionMap("xhairMap.sae");

    bindCommand(keyboard0, make, "escape", TO, "Rangefinder::bottom::cancel();");
    bindCommand(keyboard0, break, "escape", TO, "");

    bindCommand(keyboard0, make, "left", TO, "Rangefinder::bottom::prevPressed();");
    bindCommand(keyboard0, make, "right", TO, "Rangefinder::bottom::nextPressed();");
    Xhair::bindCommonKeys();
}


function Xhair::unbind()
{
    popActionMap("xhairMap.sae");
    Event::Detach(eventUse, Xhair::mute);
    Event::Detach(eventDrop, Xhair::mute);
    Event::Detach(eventNextWeapon, "return mute;");
    Event::Detach(eventPrevWeapon, "return mute;");
}


function Xhair::configMode()
{
    if($Xhair::MortarMode)
    {
        $Xhair::MortarMode = false;
        Xhair::update("", true);
    }
    $Xhair::previousBitmap = $Xhair::currentBitmap;
    $Rangefinder::top::previousBitmap = $Rangefinder::top::currentBitmap;
    $Rangefinder::bottom::previousBitmap = $Rangefinder::bottom::currentBitmap;

    $Xhair::selected = "";
    Xhair::configMenu();
}


// show menu to exit, change crosshair, top rangefinder or bottom rangefinder, or save and exit
//
function Xhair::configMenu()
{
    if($PilotMode)
        %mode = "Pilot Mode ";
    else if($Xhair::CommandMode)
        %mode = "Command Mode ";

    menu::reset();
    menu::additem("Save");
    menu::additem("Change " @ %mode @ "Crosshair");
    menu::additem("Change " @ %mode @ "Top Rangefinder");
    menu::additem("Change " @ %mode @ "Bottom Rangefinder");
    menu::additem("Set As Default");

    menu::make("<jc><f1>Select an item or press <f2>Esc<f1> to exit\n", Xhair::onSelected, Xhair::onCancelled, 5, $Xhair::selected);
}


function Xhair::onSelected(%index)
{
    $Xhair::selected = %index;

    // keep track of keypress state so we can separate the initial key repeat delay from teh key repeat rate
    $Xhair::repeating = false;

    if(%index == 0) // Save
    {
        Xhair::saveData();
        $Xhair::previousBitmap = $Xhair::currentBitmap;
        $Rangefinder::top::previousBitmap = $Rangefinder::top::currentBitmap;
        $Rangefinder::bottom::previousBitmap = $Rangefinder::bottom::currentBitmap;
        Xhair::configMenu(); // return to menu
    }
    else if(%index == 1) // Change Crosshair
    {
        Xhair::bindKeys();
        pushActionMap("xhairMap.sae");
        whud::make(xhairhelp, "50%", "25%", 400, 36, 0, 1, "<jc><f1>Use the cursor keys to change the crosshair. \n Press <f2>Enter<f1> when done, or <f2>Esc<f1> to cancel.");
    }
    else if(%index == 2) // Change Top Rangefinder
    {
        Rangefinder::top::bindKeys();
        pushActionMap("xhairMap.sae");
        whud::make(xhairhelp, "50%", "25%", 400, 36, 0, 1, "<jc><f1>Use the cursor keys to change the top rangefinder. \n Press <f2>Enter<f1> when done, or <f2>Esc<f1> to cancel.");
    }
    else if(%index == 3) // Change Bottom Rangefinder
    {
        Rangefinder::bottom::bindKeys();
        pushActionMap("xhairMap.sae");
        whud::make(xhairhelp, "50%", "25%", 400, 36, 0, 1, "<jc><f1>Use the cursor keys to change the bottom rangefinder. \n Press <f2>Enter<f1> when done, or <f2>Esc<f1> to cancel.");
    }
    else if(%index == 4) // Set as default
    {
        $Xhair::bitmap[default] = $Xhair::currentBitmap;
        $Rangefinder::top::bitmap[default] = $Rangefinder::top::currentBitmap;
        $Rangefinder::bottom::bitmap[default] = $Rangefinder::bottom::currentBitmap;
        Xhair::configMenu(); // return to menu
    }
    return;
}


function Xhair::onCancelled()
{
    if($PilotMode)
        Xhair::update(pilotmode, true);
    else if($Xhair::CommandMode)
        Xhair::update(command, true);
    else
        Xhair::update("", true);

    return;
}


function Xhair::assign(%index, %bitmap)
{
    if(%index != "")
        %bitmap = $Xhair::list[%index];

    if($PilotMode)
        %weapon = pilotmode;
    else if($Xhair::CommandMode)
        %weapon = command;
    else
        %weapon = $Inv::Name[getMountedItem(0)];

    if(%weapon != "")
    {
        Xhair::addWeapon(%weapon);
        $Xhair::bitmap[%weapon] = %bitmap;
        Xhair::update(%weapon, true);
    }
}

function Rangefinder::top::assign(%index, %bitmap)
{
    if(%index != "")
        %bitmap = $Rangefinder::list[%index];

    if($PilotMode)
        %weapon = pilotmode;
    else if($Xhair::CommandMode)
        %weapon = command;
    else
        %weapon = $Inv::Name[getMountedItem(0)];

    if(%weapon != "")
    {
        Xhair::addWeapon(%weapon);
        $Rangefinder::top::bitmap[%weapon] = %bitmap;
        Xhair::update(%weapon, true);
    }
}

function Rangefinder::bottom::assign(%index, %bitmap)
{
    if(%index != "")
        %bitmap = $Rangefinder::list[%index];

    if($PilotMode)
        %weapon = pilotmode;
    else if($Xhair::CommandMode)
        %weapon = command;
    else
        %weapon = $Inv::Name[getMountedItem(0)];

    if(%weapon != "")
    {
        Xhair::addWeapon(%weapon);
        $Rangefinder::bottom::bitmap[%weapon] = %bitmap;
        Xhair::update(%weapon, true);
    }
}


function Xhair::nextPressed()
{
    // Find current crosshair in list
    if($Xhair::list[$Xhair::currentIndex] != $Xhair::currentBitmap)
    {
        for(%i = 0; %i < $Xhair::count; %i++)
        {
            if($Xhair::list[%i] == $Xhair::currentBitmap)
                break;
        }
        $Xhair::currentIndex = %i;
    }

    $Xhair::currentIndex++;
    if($Xhair::currentIndex >= $Xhair::count)
        $Xhair::currentIndex = 0;

    Xhair::assign($Xhair::currentIndex);

    if($Xhair::repeating)
        schedule::add("Xhair::nextPressed();", $Xhair::keyRepeatDelay, xhairKeyRepeat);
    else
        schedule::add("Xhair::nextPressed();", $Xhair::keyFirstDelay, xhairKeyRepeat);

    $Xhair::repeating = true;
}


function Xhair::prevPressed()
{
    // Find current crosshair in list
    if($Xhair::list[$Xhair::currentIndex] != $Xhair::currentBitmap)
    {
        for(%i = 0; %i < $Xhair::count; %i++)
        {
            if($Xhair::list[%i] == $Xhair::currentBitmap)
                break;
        }
        $Xhair::currentIndex = %i;
    }

    $Xhair::currentIndex++;
    if($Xhair::currentIndex < 0)
        $Xhair::currentIndex = $Xhair::count - 1;

    Xhair::assign($Xhair::currentIndex);

    if($Xhair::repeating)
        schedule::add("Xhair::prevPressed();", $Xhair::keyRepeatDelay, xhairKeyRepeat);
    else
        schedule::add("Xhair::prevPressed();", $Xhair::keyFirstDelay, xhairKeyRepeat);

    $Xhair::repeating = true;
}


function Rangefinder::top::nextPressed()
{
    // Find current crosshair in list
    if($Rangefinder::list[$Rangefinder::top::currentIndex] != $Rangefinder::top::currentBitmap)
    {
        for(%i = 0; %i < $Rangefinder::count; %i++)
        {
            if($Rangefinder::list[%i] == $Rangefinder::top::currentBitmap)
                break;
        }
        $Rangefinder::top::currentIndex = %i;
    }

    $Rangefinder::top::currentIndex++;
    if($Rangefinder::top::currentIndex >= $Rangefinder::count)
        $Rangefinder::top::currentIndex = 0;

    Rangefinder::top::assign($Rangefinder::top::currentIndex);

    if($Xhair::repeating)
        schedule::add("Rangefinder::top::nextPressed();", $Xhair::keyRepeatDelay, xhairKeyRepeat);
    else
        schedule::add("Rangefinder::top::nextPressed();", $Xhair::keyFirstDelay, xhairKeyRepeat);

    $Xhair::repeating = true;
}


function Rangefinder::top::prevPressed()
{
    // Find current crosshair in list
    if($Rangefinder::list[$Rangefinder::top::currentIndex] != $Rangefinder::top::currentBitmap)
    {
        for(%i = 0; %i < $Rangefinder::count; %i++)
        {
            if($Rangefinder::list[%i] == $Rangefinder::top::currentBitmap)
                break;
        }
        $Rangefinder::top::currentIndex = %i;
    }

    $Rangefinder::top::currentIndex--;
    if($Rangefinder::top::currentIndex < 0)
        $Rangefinder::top::currentIndex = $Rangefinder::count - 1;

    Rangefinder::top::assign($Rangefinder::top::currentIndex);

    if($Xhair::repeating)
        schedule::add("Rangefinder::top::prevPressed();", $Xhair::keyRepeatDelay, xhairKeyRepeat);
    else
        schedule::add("Rangefinder::top::prevPressed();", $Xhair::keyFirstDelay, xhairKeyRepeat);

    $Xhair::repeating = true;
}



function Rangefinder::bottom::nextPressed()
{
    // Find current crosshair in list
    if($Rangefinder::list[$Rangefinder::bottom::currentIndex] != $Rangefinder::bottom::currentBitmap)
    {
        for(%i = 0; %i < $Rangefinder::count; %i++)
        {
            if($Rangefinder::list[%i] == $Rangefinder::bottom::currentBitmap)
                break;
        }
        $Rangefinder::bottom::currentIndex = %i;
    }

    $Rangefinder::bottom::currentIndex++;
    if($Rangefinder::bottom::currentIndex >= $Rangefinder::count)
        $Rangefinder::bottom::currentIndex = 0;

    Rangefinder::bottom::assign($Rangefinder::bottom::currentIndex);

    if($Xhair::repeating)
        schedule::add("Rangefinder::bottom::nextPressed();", $Xhair::keyRepeatDelay, xhairKeyRepeat);
    else
        schedule::add("Rangefinder::bottom::nextPressed();", $Xhair::keyFirstDelay, xhairKeyRepeat);

    $Xhair::repeating = true;
}


function Rangefinder::bottom::prevPressed()
{
    // Find current crosshair in list
    if($Rangefinder::list[$Rangefinder::bottom::currentIndex] != $Rangefinder::bottom::currentBitmap)
    {
        for(%i = 0; %i < $Rangefinder::count; %i++)
        {
            if($Rangefinder::list[%i] == $Rangefinder::bottom::currentBitmap)
                break;
        }
        $Rangefinder::bottom::currentIndex = %i;
    }

    $Rangefinder::bottom::currentIndex--;
    if($Rangefinder::bottom::currentIndex < 0)
        $Rangefinder::bottom::currentIndex = $Rangefinder::count - 1;

    Rangefinder::bottom::assign($Rangefinder::bottom::currentIndex);

    if($Xhair::repeating)
        schedule::add("Rangefinder::bottom::prevPressed();", $Xhair::keyRepeatDelay, xhairKeyRepeat);
    else
        schedule::add("Rangefinder::bottom::prevPressed();", $Xhair::keyFirstDelay, xhairKeyRepeat);

    $Xhair::repeating = true;
}


function Xhair::nextReleased()
{
    $Xhair::repeating = false;
    schedule::cancel(xhairKeyRepeat);
}


function Xhair::prevReleased()
{
    $Xhair::repeating = false;
    schedule::cancel(xhairKeyRepeat);
}


function Xhair::enter()
{
    whud::remove(xhairhelp);
    Xhair::unbind();
    Xhair::configMenu();
}


function Xhair::cancel()
{
    $Xhair::currentBitmap = $Xhair::previousBitmap;
    Xhair::assign("", $Xhair::currentBitmap);

    whud::remove(xhairhelp);
    Xhair::unbind();
    Xhair::configMenu();
}

function Rangefinder::top::cancel()
{
    $Rangefinder::top::currentBitmap = $Rangefinder::top::previousBitmap;
    Rangefinder::top::assign("", $Rangefinder::top::currentBitmap);

    whud::remove(xhairhelp);
    Xhair::unbind();
    Xhair::configMenu();
}

function Rangefinder::bottom::cancel()
{
    $Rangefinder::bottom::currentBitmap = $Rangefinder::bottom::previousBitmap;
    Rangefinder::bottom::assign("", $Rangefinder::bottom::currentBitmap);

    whud::remove(xhairhelp);
    Xhair::unbind();
    Xhair::configMenu();
}

function xhair::defaults()
{
    $Xhair::bitmap[default] = "";
    $Rangefinder::top::bitmap[default] = "";
    $Rangefinder::bottom::bitmap[default] = "";
    
    $Xhair::bitmap[pilotmode] = "<b1,1:writer\\xhairs\\scout.bmp>";
    $Rangefinder::top::bitmap[pilotmode] = "";
    $Rangefinder::bottom::bitmap[pilotmode] = "";
    
    $Xhair::bitmap[command] = "";
    $Rangefinder::top::bitmap[command] = "";
    $Rangefinder::bottom::bitmap[command] = "";
    
    Xhair::addWeapon("Laser Rifle"); // allows xhair.cs to save settings for the "Laser Rifle"
    $Xhair::bitmap["Laser Rifle"] = "<b1,1:writer\\xhairs\\sniper.bmp>";
    $Rangefinder::top::bitmap["Laser Rifle"] = "";
    $Rangefinder::bottom::bitmap["Laser Rifle"] = "";
    
    Xhair::addWeapon("Disc Launcher"); // allows xhair.cs to save settings for the "Disc Launcher"
    $Xhair::bitmap["Disc Launcher"] = "<b1,1:writer\\xhairs\\circle.bmp>";
    $Rangefinder::top::bitmap["Disc Launcher"] = "";
    $Rangefinder::bottom::bitmap["Disc Launcher"] = "";
    
    Xhair::addWeapon("Chaingun"); // allows xhair.cs to save settings for the "Chaingun"
    $Xhair::bitmap["Chaingun"] = "<b1,1:writer\\xhairs\\chaingun.bmp>";
    $Rangefinder::top::bitmap["Chaingun"] = "";
    $Rangefinder::bottom::bitmap["Chaingun"] = "";
    
    Xhair::addWeapon("Plasma Gun"); // allows xhair.cs to save settings for the "Plasma Gun"
    $Xhair::bitmap["Plasma Gun"] = "<b1,1:writer\\xhairs\\circle2.bmp>";
    $Rangefinder::top::bitmap["Plasma Gun"] = "";
    $Rangefinder::bottom::bitmap["Plasma Gun"] = "";
    
    Xhair::addWeapon("Repair Gun"); // allows xhair.cs to save settings for the "Repair Gun"
    $Xhair::bitmap["Repair Gun"] = "<b1,1:writer\\xhairs\\repairgun.bmp>";
    $Rangefinder::top::bitmap["Repair Gun"] = "";
    $Rangefinder::bottom::bitmap["Repair Gun"] = "";
    
    Xhair::addWeapon("ELF Gun"); // allows xhair.cs to save settings for the "ELF Gun"
    $Xhair::bitmap["ELF Gun"] = "<b1,1:writer\\xhairs\\elf.bmp>";
    $Rangefinder::top::bitmap["ELF Gun"] = "";
    $Rangefinder::bottom::bitmap["ELF Gun"] = "";
    
    Xhair::addWeapon("Blaster"); // allows xhair.cs to save settings for the "Blaster"
    $Xhair::bitmap["Blaster"] = "<b1,1:writer\\xhairs\\blaster.bmp>";
    $Rangefinder::top::bitmap["Blaster"] = "";
    $Rangefinder::bottom::bitmap["Blaster"] = "";
    
    Xhair::addWeapon("Targeting Laser"); // allows xhair.cs to save settings for the "Targeting Laser"
    $Xhair::bitmap["Targeting Laser"] = "<b1,1:writer\\xhairs\\target.bmp>";
    $Rangefinder::top::bitmap["Targeting Laser"] = "";
    $Rangefinder::bottom::bitmap["Targeting Laser"] = "";
    
    Xhair::addWeapon("Mortar"); // allows xhair.cs to save settings for the "Mortar"
    $Xhair::bitmap["Mortar"] = "<b1,1:writer\\xhairs\\mortar_green.bmp>";
    $Rangefinder::top::bitmap["Mortar"] = "<b1,1:writer\\rangefinders\\middle_green.bmp>";
    $Rangefinder::bottom::bitmap["Mortar"] = "<b1,1:writer\\rangefinders\\bottom_green.bmp>";
    
    Xhair::addWeapon("Grenade Launcher"); // allows xhair.cs to save settings for the "Grenade Launcher"
    $Xhair::bitmap["Grenade Launcher"] = "<b1,1:writer\\xhairs\\rangetop_green.bmp>";
    $Rangefinder::top::bitmap["Grenade Launcher"] = "<b1,1:writer\\rangefinders\\middle_green.bmp>";
    $Rangefinder::bottom::bitmap["Grenade Launcher"] = "<b1,1:writer\\rangefinders\\bottom_green.bmp>";
}

function xhair::save()
{
    AddExportText("    // Enter xhair config mode");

    ExportBind("Xhair::configMode();", "//bind(keyboard0, make, r_alt, \"x\", TO, \"Xhair::configMode();\");");
    ExportBind("Xhair::configMode_break", "//bind(keyboard0, break, r_alt, \"x\", TO, \"\", Xhair::configMode_break);");

    AddExportText("");
    AddExportText("    // Toggle your \"command mode\" reticle and rangefinders on/off");

    ExportBind("Xhair::CommandModeToggle();", "//bind(keyboard0, make, r_alt, \"c\", TO, \"Xhair::CommandModeToggle();\");");
    ExportBind("Xhair::CommandModeToggle_break", "//bind(keyboard0, break, r_alt, \"c\", TO, \"\", Xhair::CommandModeToggle_break);");

    AddExportText("");
    AddExportText("    // Force your \"Mortar\" reticle and rangefinders on/off");

    ExportBind("Xhair::ForceMortarToggle();", "//bind(keyboard0, make, r_alt, \"m\", TO, \"Xhair::ForceMortarToggle();\");");
    ExportBind("Xhair::ForceMortarToggle_break", "//bind(keyboard0, break, r_alt, \"m\", TO, \"\", Xhair::ForceMortarToggle_break);");
}

WriterPrefs::save("xhair");

function xhair::init()
{
    needs("writer\\xhair.cs", "writer\\event.cs 2.7",
                              "writer\\inventory.cs 3.3",
                              "writer\\menu.cs 1.3",
                              "writer\\save.cs 2.3",
                              "writer\\weapon_switch.cs 2.5",
                              "writer\\wHUD.cs 1.2",
                              "writer\\you_died.cs 1.6",
                              "writer\\you_respawned.cs 1.2");

    if(isFile("config\\xhair_data.cs"))
    {
        exec("xhair_data.cs");
    }
    else
    {
        // create default xhair_data.cs
        xhair::defaults();
        xhair::saveData();
    }

    Event::Attach(eventDropWeapon, Xhair::onDropWeapon);
    Event::Attach(eventInventoryTableReady, "Xhair::Setup();");
    Event::Attach(eventWeaponSwitch, Xhair::onWeaponSwitch);
    Event::Attach(eventPilotModeOn, "Xhair::onPilotModeOn();");
    Event::Attach(eventPilotModeOff, "Xhair::onPilotModeOff();");
    Event::Attach(eventYouDied, "Xhair::hide();");
    Event::Attach(eventChangeMission, "Xhair::hide();");
    Event::Attach(eventScreenModeChanged, "Xhair::relocate();");
    Event::Attach(eventScreenSizeChanged, "Xhair::relocate();");
    Event::Attach(eventYouRespawned, "Xhair::onYouRespawned();");
}
Event::Attach(writerInit, "xhair::init();");

if(!$UsingWriterLoader) xhair::init();
